/*
 * Definitions used in representing logic arrays
 */

#define N	0
#define Z	1		/* representation for zero */
#define O	2		/* representation for one */
#define X	3		/* representation for don't care */

/* A cube (i.e., a product term) */
struct cube {
	struct cube *c_next;
	char c_logic[1];
};

/* An array of cubes, representing a sum of product terms */
struct array {
	int	a_noin, a_nvar;
	struct cube *a_first, *a_last;
	struct array *a_next;
};

/* A list of arrays */
struct arraylist {
	struct array *l_first, *l_last;
};

extern int debug;		/* extras in printouts */

extern struct arraylist hfrelist;

#define cfree(p)	free(p)
#define afree(p)	aadd(&hfrelist, p)

struct array *newarray(), *rdary(), *acopy();
struct cube *newcube();
struct array *axc(), *intersect();
struct array *ashc(), *sharp();
struct array *expr_array(), *conv_func();
struct array *conv_1_expr();
struct array *univ_array(), *inv_array();
struct array *picko(), *somin(), *momin();

#define arr_compat(a, b)	{   if( a->a_noin != b->a_noin \
					|| a->a_nvar != b->a_nvar ) \
						incompat();  }

