
L	[A-Za-z_]
LD	[A-Za-z_0-9]
H	[A-Fa-f0-9]

%%
input		return INPUT;
output		return OUTPUT;
internal	return INTERNAL;
active_low	return ACTIVE_LOW;
active_high	return ACTIVE_HIGH;
clocked_by	return CLOCKED_BY;
latched_by	return LATCHED_BY;
enabled_by	return ENABLED_BY;
reset_by	return RESET_BY;
fast		return KFAST;
hazard_free	return HAZARD_FREE;
group		return KGROUP;
define		return DEFINE;
function	return KFUNCTION;
truth_table	return TRUTH_TABLE;
sum_of_products	return SUM_OF_PRODUCTS;
state_machine	return STATE_MACHINE;
asynchronous	return ASYNCHRONOUS;
true		return TRUE;
false		return FALSE;
all_states	return ALL_STATES;
other_states	return OTHER_STATES;
include		return INCLUDE;
if		return IF;
then		return THEN;
elsif		return ELSIF;
else		return ELSE;
endif		return ENDIF;
define_pal	return DEFINE_PAL;

{L}{LD}*	{ yylval.y_name = strsave(yytext); return IDENT; }
"=="		return EQUAL;
"!="		return NOTEQUAL;
"<<"		return LESS;
"<="		return LESSEQ;
">>"		return GTR;
">="		return GTREQ;
":="		return BECOMES;
"=>"		return IMPLIES;
"*"		return '&';
"+"		return '|';
"!"		return '~';
\"[^"]*\"	{ yylval.y_name = strsave(yytext); return STRING; }
\${H}*		{ yylval.y_int = strtol(yytext+1, NULL, 16); return HEXNUM; }

[ \t]		;
\n		{ extern int lineno; ++lineno; }

"/*"		{	/* consume a comment */
			int ch;
			extern int lineno;

			ch = input();
			do {
				while( ch != '*' && ch != 0 ){
					if (ch == '\n')
						++lineno;
					ch = input();
				}
				if( ch == 0 )		/* end of file */
					break;
				ch = input();
			} while( ch != '/' );
		}

.		return yytext[0];

